Subject: Re: [RFC PATCH] net: introduce HW Rate Limiting Driver API

From: Jakub Kicinski <[email-masked]>
Date: Mon, 3 Jun 2024 16:29:31 -0700

On Mon, 03 Jun 2024 13:11:39 +0200 Paolo Abeni wrote:
> > ... and also what confused me here.
> > 
> > How are you going to do 2 layers of grouping with arbitrary shaping?
> > We need arbitrary inner nodes. Unless I'm missing a trick.  
> 
> I guess this part really needs some talk. I also don't understand your
> doubt above.

Each layer of shaping corresponds to some level of privilege or control.
Saying that we only need one layer is like saying that we only need one
layer of cgroups.

For example - application may want to WRR/shape between two sets of
queues (e.g. data and control) and then we may wrap that application 
up in a container, and WRR/shape multiple containers together.